#include <iostream>
#include <iomanip>
#include "Real.h"

using namespace std;
using namespace RealLib;

int main(int argc, char **argv)
{
    int precision = 32;
    if(argc > 1){
        precision = atoi(argv[1]);
    }
    printf("Precision: %d\n", precision);

    clock_t begin = clock();

    long double x0 = 0.9;

    for(int i = 0; i < 53; i++){
      x0 = 3.999*x0*(1- x0);
    }

    printf("%LF\n", x0);
    clock_t end = clock();
    double time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;

    printf("%lf\n",  time_spent);


    begin = clock();

    InitializeRealLib();
    Real x1("0.9");
    Real x2(1);
    Real x3("3.999");

    for(int i = 0; i < 53; i++){
      x1 = x3*(x1*(x2 - x1));
    }
    cout << setprecision(precision) << x1 << endl;

    FinalizeRealLib();

    end = clock();
    time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;

    printf("Time spent: %lf\n",  time_spent);

    return 0;
}
