#include <iostream>
#include <iomanip>
#include "Real.h"

using namespace std;
using namespace RealLib;

int main(int argc, char **argv)
{
    clock_t begin = clock();
    InitializeRealLib();

    Real a0(1), b0, t0, p0(1), e(2), f, g(1), h(4), j(1), k, l, m, n, x, c(10);

    f = sqrt(e);
    b0 = g / f;
    t0 = j / h;

    int i = 15;
    do{
        i--;
        k = (a0 + b0)/2;
        l = sqrt(a0*b0);
        m = t0 - p0*(a0 - k)*(a0 - k);
        n = p0*2;
        a0 = k;
        b0 = l;
        t0 = m;
        p0 = n;
    }
    while(i > 0);

    x = (a0 + b0)*(a0 + b0)/(4*t0);

    clock_t start;
    clock_t stop;
    double time;

    for(int z = 1; z < 101; z++){
       start = clock();
        cout << setprecision(z);
       cout << "Pi: " << x << "\n";
       cout << "Precision: " << GetCurrentPrecision() << "\n";
       cout << "Count: " << z << "\n";
       stop = clock();
       time = (double)(stop - start)/ CLOCKS_PER_SEC;
       printf("Time: %lf\n",  time);
    }

    FinalizeRealLib();

    clock_t end = clock();
    double time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;
    printf("Time spent: %lf\n",  time_spent);

    return 0;
}
