#include <iostream>
#include <iomanip>
#include "Real.h"

using namespace std;
using namespace RealLib;

int main(int argc, char **argv)
{
    int precision = 32;
    if(argc > 1){
        precision = atoi(argv[1]);
    }
    printf("Precision: %d\n", precision);

    clock_t begin = clock();
    InitializeRealLib();

    Real a(4), b(2), c(2), d(10), e("-10000"), f, g, x, fin;

    f = Pi / a;
    g = sqrt(b);
    x = c + exp(e*log(d));
    fin = sin(f) - (g/x);

    cout << setprecision(precision) << fin << endl;
    cout  << fin.IsNonZero() << endl;
    cout << setprecision(precision) << fin << endl;

    FinalizeRealLib();

    clock_t end = clock();
    double time_spent = (double)(end - begin)/CLOCKS_PER_SEC;

    printf("Time spent: %lf\n",  time_spent);

    return 0;
}
