#include "xr.h"
#include <time.h>

int main(int argc, char **argv) {

    clock_t begin = clock();
    long double x0 = 0.9;

    for(int i = 0; i < 53; i++){
      x0 = 3.999*x0*(1- x0);
    }

    printf("%LF\n",x0);
    clock_t end = clock();
    double time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;

    printf("%lf\n",  time_spent);

    int precision = 32;
    if(argc > 1){
      precision = atoi(argv[1]);
    }
    printf("Precision: %d\n", precision);

    begin = clock();

    xr_t x1 = xr_init(9, 1);
    x1 = xr_divi(x1, 10);
    xr_t x2 = xr_init(1, 1);
    xr_t x3 = xr_init(3999, 1);
    xr_t x4 = xr_divi(x3, 1000);

    for(int i = 0; i < 53; i++){
      x1 = xr_mul(x4, xr_mul(x1,xr_sub(x2, x1)));
    }

    end = clock();
    time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;
    printf("Time spent: %lf\n",  time_spent);

    return 0;
}

