#include <time.h>
#include "xr.h"

int main(int argc, char **argv) {

  int precision = 32;
  if(argc > 1){
    precision = atoi(argv[1]);
  }
  printf("Precision: %d\n", precision);

  clock_t begin = clock();
  xr_t x;
  xr_t y;
  xr_t z;
  xr_t a = xr_init(1,1);
  xr_t b = xr_init(2,1);
  x = xr_divi(a,  7);
  y = xr_sqrt(b);
  z = xr_add(x,  y);

  printf("%d\n",xr_print(z, precision));

  clock_t end = clock();
  double time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;

  printf("Time spent: %lf\n",  time_spent);

  return 0;
}

