#include "iRRAM/lib.h"

using namespace iRRAM;

int precision = 32;
int iRRAM_compute(const int& dummy) {

   clock_t begin = clock();

   REAL x1 = "0.9";
   REAL x2 = 1;
   REAL x3 = "3.999";

   for(int i = 0; i < 53; i++){
      x1 = x3*(x1*(x2 - x1));
   }
   cout << setRwidth(precision + 8) << "\n\n";
   cout << x1 << "\n\n";

   clock_t end = clock();
   double time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;
   printf("Time spent: %lf\n",  time_spent);

   return 0;
}

int main (int argc,char **argv)
{
   if(argc > 1){
      precision = atoi(argv[1]);
   }
   printf("Precision: %d\n", precision);

   clock_t begin = clock();

   long double x0 = 0.9;

   for(int i = 0; i < 53; i++){
      x0 = 3.999*x0*(1- x0);
   }

   printf("%LF\n",x0);
   clock_t end = clock();
   double time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;
   printf("Time spent: %lf\n",  time_spent);

   iRRAM_initialize(argc,argv);
   return iRRAM_exec(iRRAM_compute,0);
}
