#include "iRRAM/lib.h"

using namespace iRRAM;

int precision = 32;
int iRRAM_compute(const int& dummy) {

    int presnost = precision;
    REAL b0, t0, f, k, l, m, n, u, start, x;
    REAL a0 = 1;
    REAL p0 = 1;
    REAL e = 2;
    REAL g = 1;
    REAL h = 4;
    REAL j = 1;
    REAL p = 1;
    REAL app = 1;
    REAL c = 10;

    for(int i = 0; i < presnost; i++){
        app = app*c;
    }

    u = p / app;
    f = sqrt(e);
    b0 = g / f;
    t0 = j / h;

    do{
        k = (a0 + b0)/2;
        l = sqrt(a0*b0);
        m = t0 - p0*(a0 - k)*(a0 - k);
        n = p0*2;
        a0 = k;
        b0 = l;
        t0 = m;
        p0 = n;
        start = a0 - b0;
    }
    while(start > u);

    x = (a0 + b0)*(a0 + b0)/(4*t0);

    cout << setRwidth(presnost +8) << "\n\n";
    cout << x << "\n\n";

    return 0;
}

int main(int argc, char **argv)
{
    if(argc > 1){
        precision = atoi(argv[1]);
    }
    printf("Precision: %d\n", precision);

    clock_t begin = clock();

    iRRAM_initialize(argc,argv);
    int k = iRRAM_exec(iRRAM_compute,0);
    clock_t end = clock();
    double time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;
    printf("Time spent: %lf\n",  time_spent);

    return k;
}
