#include "iRRAM/lib.h"

using namespace iRRAM;

int iRRAM_compute(const int& dummy) {

    REAL b0, t0, f, k, l, m, n, u, x;
    REAL a0 = 1;
    REAL p0 = 1;
    REAL e = 2;
    REAL g = 1;
    REAL h = 4;
    REAL j = 1;
    REAL c = 10;


    f = sqrt(e);
    b0 = g / f;
    t0 = j / h;

    int i = 15;
    do{
        i--;
        k = (a0 + b0)/2;
        l = sqrt(a0*b0);
        m = t0 - p0*(a0 - k)*(a0 - k);
        n = p0*2;
        a0 = k;
        b0 = l;
        t0 = m;
        p0 = n;
    }
    while (i > 0);

    x = (a0 + b0)*(a0 + b0)/(4*t0);

    sizetype error;
    x.geterror(error);

    clock_t start;
    clock_t stop;
    double time;

    for(int z = 100; z > 0; z--){
       start = clock();
       cout << setRwidth(z + 8);
       cout << "Pi: " << x << "\n";
       cout << "Precision: " << error.exponent << "\n";
       cout << "Count: " << z << "\n";
       stop = clock();
       time = (double)(stop - start)/ CLOCKS_PER_SEC;
       printf("Time: %lf\n",  time);
    }

    return 0;
}

int main(int argc, char **argv)
{
    clock_t begin = clock();

    iRRAM_initialize(argc,argv);
    int k = iRRAM_exec(iRRAM_compute,0);
    clock_t end = clock();
    double time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;
    printf("Time spent: %lf\n",  time_spent);

    return k;
}
