#include "iRRAM/lib.h"

using namespace iRRAM;

int precision = 32;
int iRRAM_compute(const int& dummy) {

   REAL f, g, x, fin;

   REAL a = 4;
   REAL b = 2;
   REAL c = 2;
   REAL d = 10;
   REAL e = "-10000";

   f = pi() / a;
   g = sqrt(b);
   x = c + exp(e*log(d));
   fin = sin(f) - (g/x);

   cout << setRwidth(precision + 8);

   cout << fin << "\n";

   if(fin > 0){
      cout << "Not same\n";
   }
   else {
      cout << "Same\n";
   }

   cout << setRwidth(precision + 8);
   cout << fin << "\n";

   return 0;
}

int main (int argc,char **argv)
{
   if(argc > 1){
      precision = atoi(argv[1]);
   }
   printf("Precision: %d\n", precision);

   clock_t begin = clock();

   iRRAM_initialize(argc,argv);
   int k = iRRAM_exec(iRRAM_compute, 0);

   clock_t end = clock();
   double time_spent = (double)(end - begin)/ CLOCKS_PER_SEC;
   printf("Time spent: %lf\n",  time_spent);

   return k;
}
